VERSION 5.00
Begin VB.UserControl ProgressPie 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   570
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   570
   ForeColor       =   &H006A240A&
   ScaleHeight     =   38
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   38
   ToolboxBitmap   =   "ProgressPie.ctx":0000
   Begin VB.PictureBox pieBuf 
      AutoRedraw      =   -1  'True
      Height          =   315
      Left            =   120
      ScaleHeight     =   17
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   17
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   315
   End
End
Attribute VB_Name = "ProgressPie"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Pie Progress Indicator Control
' Written by:
'   Michael Karas
'   Carousel Design Solutions
'   www.CarouselDesign.com
'
' You may incorporate all or parts of this program into your own project.
' Keep in mind that you got this code free and as such Carousel Design Solutions
' has no responsibility to you, your customers, or anyone else regarding the use
' of this program code. No support or warrenty of any kind can be provided. All
' liability falls upon the user of this code and thus you must judge the suitability
' of this code to your application and usage.
'
' This control is a round progress indicator control that can be placed on a form
' to act as a percent completion progress bar. The control can display in one of two
' styles, either as a colored pie slice or as the hands of a stopwatch type clock.
' The progress display control can be sized to any suitable size at design time. The
' center point of the control is placed at the center of the rectangular control region.
' the radus is adjusted to that the control image fits within the narrower of the width
' or height.
'
' This control the following property settings all of which are read/write at both
' design time and run time. The properties are:
'
'   ProgressPie.Style As eDisplayStyle  Controls the display style of the progress
'                                       control. The choices available are:
'
'                                             PieStyle = 0
'                                             ClkStype = 1
'
'   ProgressPie.BackColor As OLE_COLOR  Specifies the color of the background rectangle
'                                       of the control.
'
'   ProgressPie.ForeColor As OLE_COLOR  Specifies the foreground color of the progress
'                                       pie or the clock hands.
'
'   ProgressPie.Percent As Long         Specifies the integer percentage complete of the
'                                       progress control from 0 -> 100%.
'
'   ProgressPie.Max As Long             When there is a range of values that specify the
'                                       none to full image of the progress control this
'                                       property specifies the value for the upper end of
'                                       the range.
'
'   ProgressPie.Min As Long             When there is a range of values that specify the
'                                       none to full image of the progress control this
'                                       property specifies the value for the lower end of
'                                       the range.
'
'   ProgressPie.Value As Long           When there is a range of values that specify the
'                                       none to full image of the progress control this
'                                       property specifies the value current position
'                                       within the range.
'

Option Explicit

' specify the Windows API function which is used to copy the progress control image from the
' drawing box to the screen display image.
Private Declare Function BitBlt Lib "gdi32.dll" (ByVal hdcDest As Long, ByVal nXDest As Long, _
                         ByVal nYDest As Long, ByVal nWidth As Long, ByVal nHeight As Long, _
                         ByVal hdcSrc As Long, ByVal nXSrc As Long, ByVal nYSrc As Long, _
                         ByVal dwRop As Long) As Long

' specify the progress control display styles
Public Enum eDisplayStyle
    PieStyle = 0
    ClkStyle = 1
End Enum

'
' declare the constants that represent the default values of the properties
' in the user control
'
Private Const DEFAULT_FORE_COLOR As Long = 5242880      ' RGB(0, 0, 80)
Private Const DEFAULT_BACK_COLOR As Long = &H8000000F   ' Button Face
Private Const DEFAULT_STYLE As Integer = PieStyle       ' pie chart type

' local copies of the controls properties
Private mStyle As eDisplayStyle                 ' currently selected style
Private mPercent As Long                        ' percentage of range displayed
Private mMax As Long                            ' upper end value of range to display
Private mMin As Long                            ' lower end of value of range to display
Private mValue As Long                          ' current position within range

'
' property value routines for getting and setting the states of the user control
'

' property handlers for the Style Property
Public Property Get Style() As eDisplayStyle

    Style = mStyle

End Property

Public Property Let Style(NewStyle As eDisplayStyle)

    mStyle = NewStyle
    UserControl_Paint
    PropertyChanged "Style"
   
End Property

' property handlers for the BackColor Property
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501

    BackColor = UserControl.BackColor

End Property

Public Property Let BackColor(NewBackColor As OLE_COLOR)

    UserControl.BackColor = NewBackColor
    UserControl_Paint
    PropertyChanged "BackColor"
   
End Property

' property handlers for the ForeColor Property
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute ForeColor.VB_UserMemId = -513

    ForeColor = UserControl.ForeColor

End Property

Public Property Let ForeColor(NewForeColor As OLE_COLOR)

    UserControl.ForeColor = NewForeColor
    UserControl_Paint
    PropertyChanged "ForeColor"
   
End Property

' property handlers for the Percent Property
Public Property Get Percent() As Long

    Percent = mPercent

End Property

Public Property Let Percent(NewPercent As Long)
Attribute Percent.VB_ProcData.VB_Invoke_PropertyPut = ";Misc"

    If NewPercent < 0 Then
        NewPercent = 0
    End If
    If NewPercent > 100 Then
        NewPercent = 100
    End If
    
    If NewPercent <> mPercent Then
        mPercent = NewPercent
        mValue = Int(mMin + (mPercent * (mMax - mMin)) / 100)
        UserControl_Paint
    End If
    PropertyChanged "Percent"
   
End Property

' property handlers for the Max Property
Public Property Get Max() As Long

    Max = mMax

End Property

Public Property Let Max(NewMax As Long)
Attribute Max.VB_ProcData.VB_Invoke_PropertyPut = ";Misc"

    mMax = NewMax
   
    If mMax < mMin Then
        mMin = mMax
    End If
    UserControl_Paint
    PropertyChanged "Max"
   
End Property

' property handlers for the Min Property
Public Property Get Min() As Long

    Min = mMin

End Property

Public Property Let Min(NewMin As Long)
Attribute Min.VB_ProcData.VB_Invoke_PropertyPut = ";Misc"

    mMin = NewMin

    If mMin > mMax Then
        mMax = mMin
    End If
    UserControl_Paint
    PropertyChanged "Min"
   
End Property

' property handlers for the Value Property
Public Property Get Value() As Long

    Value = mValue

End Property

Public Property Let Value(NewValue As Long)
Attribute Value.VB_ProcData.VB_Invoke_PropertyPut = ";Misc"

    If NewValue < mMin Then
        mMin = NewValue
    End If
    
    If NewValue > mMax Then
        mMax = NewValue
    End If
    
    mValue = NewValue
    
    If mMax - mMin > 0 Then
        mPercent = Int(((mValue - mMin) / (mMax - mMin)) * 100)
    Else
        mPercent = 0
    End If
    UserControl_Paint
   
End Property

' Initialize the default states of the controls properties
' this routine sets up some default value copies of the
' properties so that the Write and Read properties methods
' use the same default values as set here.
Private Sub UserControl_InitProperties()
       
    mStyle = DEFAULT_STYLE
    mMin = 0
    mValue = 0
    mPercent = 0
    mMax = 100
    UserControl.ForeColor = DEFAULT_FORE_COLOR
    UserControl.BackColor = DEFAULT_BACK_COLOR

End Sub

' display the progress control image. this paints into a picture box and
' then the picture box contents is copies to the form display area using
' a fast Windows BLT call.
Private Sub UserControl_Paint()
   
    Dim X As Single                             ' X center for the progress image
    Dim Y As Single                             ' Y center for the progress image
    Dim Radius As Single                        ' radius of the progress image
    Dim StAng As Single                         ' start angle of the pie image
    Dim EnAng As Single                         ' end angle of the pie image
    Dim Pct As Single                           ' floating point copy of percentage
    Const PI As Single = 3.14159265358979

    pieBuf.BackColor = UserControl.BackColor    ' get copies of the colors into the
    pieBuf.ForeColor = UserControl.ForeColor    ' drawing box
     
    ' clear the background of box
    pieBuf.Line (pieBuf.ScaleLeft, pieBuf.ScaleTop)-(pieBuf.ScaleWidth, _
                  pieBuf.ScaleHeight), UserControl.BackColor, BF
   
    ' select the display image type based on style property
    Select Case mStyle
    
        ' pie slice image
        Case PieStyle
            If mPercent > 0 Then
                X = (pieBuf.ScaleWidth / 2)         ' get center of the box
                Y = (pieBuf.ScaleHeight / 2)
                
                If pieBuf.ScaleWidth > pieBuf.ScaleHeight Then ' radius is min of
                    Radius = (pieBuf.ScaleHeight / 2) - 1      ' height and width
                Else
                    Radius = (pieBuf.ScaleWidth / 2) - 1
                End If
                
                EnAng = (PI / 2#)                               ' end at 12:00 (90 deg)
                StAng = EnAng + ((PI * 2) - (((PI * 2) * mPercent) / 100#)) ' compute start angle
                If StAng > (2 * PI) Then
                    StAng = StAng - (2 * PI)
                End If
                
                ' make angles negative for pie slices
                StAng = StAng * -1#
                EnAng = EnAng * -1#
                
                pieBuf.FillColor = UserControl.ForeColor        ' set fill color and
                pieBuf.FillStyle = 0                            ' solid fill style
                
                pieBuf.Circle (X, Y), Radius, , StAng, EnAng    ' draw filled arc pie piece.
            End If
            
        ' stop clock hands type image
        Case ClkStyle
            X = (pieBuf.ScaleWidth / 2)         ' get center of the box
            Y = (pieBuf.ScaleHeight / 2)
            
            If pieBuf.ScaleWidth > pieBuf.ScaleHeight Then ' radius is min of
                Radius = (pieBuf.ScaleHeight / 2) - 1      ' height and width
            Else
                Radius = (pieBuf.ScaleWidth / 2) - 1
            End If
            
            EnAng = (PI / 2#)                               ' end at 12:00 (90 deg)
            StAng = EnAng + ((PI * 2) - (((PI * 2) * mPercent) / 100#)) ' compute start angle
            If StAng > (2 * PI) Then
                StAng = StAng - (2 * PI)
            End If
        
            pieBuf.Line (X, Y)-(X, Y - Radius)               ' draw the line from center to 12:00
            
            If mPercent > 0 Then                             ' draw line from center to % position CW
                pieBuf.Line (X, Y)-(X + (Radius * Cos(StAng)), Y - (Radius * Sin(StAng)))
            End If
            
    End Select

    ' blast the drawing box contents to the form client rectangle
    BitBlt UserControl.hDC, UserControl.ScaleLeft, UserControl.ScaleTop, UserControl.ScaleWidth, _
                            UserControl.ScaleHeight, pieBuf.hDC, pieBuf.ScaleLeft, pieBuf.ScaleTop, vbSrcCopy

End Sub

' routine to support the getting of the current properties values from
' the controls host container property bag
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    mStyle = PropBag.ReadProperty("Style", DEFAULT_STYLE)
    mMax = PropBag.ReadProperty("Max", 100)
    mMin = PropBag.ReadProperty("Min", 0)
    mValue = PropBag.ReadProperty("Value", 0)
    mPercent = PropBag.ReadProperty("Percent", 0)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", DEFAULT_BACK_COLOR)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", DEFAULT_FORE_COLOR)
   
End Sub

' routine to support the saving of the current properties values into
' the controls host container property bag.
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    PropBag.WriteProperty "Style", mStyle, DEFAULT_STYLE
    PropBag.WriteProperty "Max", mMax, 100
    PropBag.WriteProperty "Min", mMin, 0
    PropBag.WriteProperty "Value", mValue, 0
    PropBag.WriteProperty "Percent", mPercent, 0
    PropBag.WriteProperty "BackColor", UserControl.BackColor, DEFAULT_BACK_COLOR
    PropBag.WriteProperty "ForeColor", UserControl.ForeColor, DEFAULT_FORE_COLOR
   
End Sub

' this routine re-sizes the drawing buffer picture box to match the size of the client region
' of the progress control
Private Sub UserControl_Resize()

    pieBuf.Move 0, 0, UserControl.Width / Screen.TwipsPerPixelX, UserControl.Height / Screen.TwipsPerPixelY

End Sub

